    001/* ===========================================================
    002 * JFreeChart : a free chart library for the Java(tm) platform
    003 * ===========================================================
    004 *
    005 * (C) Copyright 2000-2011, by Object Refinery Limited and Contributors.
    006 *
    007 * Project Info:  http://www.jfree.org/jfreechart/index.html
    008 *
    009 * This library is free software; you can redistribute it and/or modify it
    010 * under the terms of the GNU Lesser General Public License as published by
    011 * the Free Software Foundation; either version 2.1 of the License, or
    012 * (at your option) any later version.
    013 *
    014 * This library is distributed in the hope that it will be useful, but
    015 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017 * License for more details.
    018 *
    019 * You should have received a copy of the GNU Lesser General Public
    020 * License along with this library; if not, write to the Free Software
    021 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022 * USA.
    023 *
    024 * [Oracle and Java are registered trademarks of Oracle and/or its affiliates.
    025 * Other names may be trademarks of their respective owners.]
    026 *
    027 * ----------------------
    028 * PieLabelLinkStyle.java
    029 * ----------------------
    030 * (C) Copyright 2008, by Object Refinery Limited.
    031 *
    032 * Original Author:  David Gilbert (for Object Refinery Limited);
    033 * Contributor(s):   -;
    034 *
    035 * Changes:
    036 * --------
    037 * 31-Mar-2008 : Version 1 (DG);
    038 *
    039 */
    040
    041package org.jfree.chart.plot;
    042
    043import java.io.ObjectStreamException;
    044import java.io.Serializable;
    045
    046/**
    047 * Used to indicate the style for the lines linking pie sections to their
    048 * corresponding labels.
    049 *
    050 * @since 1.0.10
    051 */
    052public final class PieLabelLinkStyle implements Serializable {
    053
    054    /** STANDARD. */
    055    public static final PieLabelLinkStyle STANDARD
    056            = new PieLabelLinkStyle("PieLabelLinkStyle.STANDARD");
    057
    058    /** QUAD_CURVE. */
    059    public static final PieLabelLinkStyle QUAD_CURVE
    060            = new PieLabelLinkStyle("PieLabelLinkStyle.QUAD_CURVE");
    061
    062    /** CUBIC_CURVE. */
    063    public static final PieLabelLinkStyle CUBIC_CURVE
    064            = new PieLabelLinkStyle("PieLabelLinkStyle.CUBIC_CURVE");
    065
    066    /** The name. */
    067    private String name;
    068
    069    /**
    070     * Private constructor.
    071     *
    072     * @param name  the name.
    073     */
    074    private PieLabelLinkStyle(String name) {
    075        this.name = name;
    076    }
    077
    078    /**
    079     * Returns a string representing the object.
    080     *
    081     * @return The string.
    082     */
    083    public String toString() {
    084        return this.name;
    085    }
    086
    087    /**
    088     * Returns <code>true</code> if this object is equal to the specified
    089     * object, and <code>false</code> otherwise.
    090     *
    091     * @param obj  the object (<code>null</code> permitted).
    092     *
    093     * @return A boolean.
    094     */
    095    public boolean equals(Object obj) {
    096        if (this == obj) {
    097            return true;
    098        }
    099        if (!(obj instanceof PieLabelLinkStyle)) {
    100            return false;
    101        }
    102        PieLabelLinkStyle style = (PieLabelLinkStyle) obj;
    103        if (!this.name.equals(style.toString())) {
    104            return false;
    105        }
    106        return true;
    107    }
    108
    109    /**
    110     * Returns a hash code for this instance.
    111     *
    112     * @return A hash code.
    113     */
    114    public int hashCode() {
    115        return this.name.hashCode();
    116    }
    117
    118    /**
    119     * Ensures that serialization returns the unique instances.
    120     *
    121     * @return The object.
    122     *
    123     * @throws ObjectStreamException if there is a problem.
    124     */
    125    private Object readResolve() throws ObjectStreamException {
    126        Object result = null;
    127        if (this.equals(PieLabelLinkStyle.STANDARD)) {
    128            result = PieLabelLinkStyle.STANDARD;
    129        }
    130        else if (this.equals(PieLabelLinkStyle.QUAD_CURVE)) {
    131            result = PieLabelLinkStyle.QUAD_CURVE;
    132        }
    133        else if (this.equals(PieLabelLinkStyle.CUBIC_CURVE)) {
    134            result = PieLabelLinkStyle.CUBIC_CURVE;
    135        }
    136        return result;
    137    }
    138
    139}